// Code generated by protoc-gen-go. DO NOT EDIT.
// source: benchmarks.proto

package sonm

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// BenchmarkType describes hardware group for which this benchmark is applicable
type DeviceType int32

const (
	DeviceType_DEV_UNKNOWN     DeviceType = 0
	DeviceType_DEV_CPU         DeviceType = 1
	DeviceType_DEV_GPU         DeviceType = 2
	DeviceType_DEV_RAM         DeviceType = 3
	DeviceType_DEV_STORAGE     DeviceType = 4
	DeviceType_DEV_NETWORK_IN  DeviceType = 5
	DeviceType_DEV_NETWORK_OUT DeviceType = 6
)

var DeviceType_name = map[int32]string{
	0: "DEV_UNKNOWN",
	1: "DEV_CPU",
	2: "DEV_GPU",
	3: "DEV_RAM",
	4: "DEV_STORAGE",
	5: "DEV_NETWORK_IN",
	6: "DEV_NETWORK_OUT",
}
var DeviceType_value = map[string]int32{
	"DEV_UNKNOWN":     0,
	"DEV_CPU":         1,
	"DEV_GPU":         2,
	"DEV_RAM":         3,
	"DEV_STORAGE":     4,
	"DEV_NETWORK_IN":  5,
	"DEV_NETWORK_OUT": 6,
}

func (x DeviceType) String() string {
	return proto.EnumName(DeviceType_name, int32(x))
}
func (DeviceType) EnumDescriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

// SplittingAlgorithm describes how a benchmark is mapped to a device.
type SplittingAlgorithm int32

const (
	SplittingAlgorithm_NONE         SplittingAlgorithm = 0
	SplittingAlgorithm_PROPORTIONAL SplittingAlgorithm = 1
	SplittingAlgorithm_MIN          SplittingAlgorithm = 2
	SplittingAlgorithm_MAX          SplittingAlgorithm = 3
)

var SplittingAlgorithm_name = map[int32]string{
	0: "NONE",
	1: "PROPORTIONAL",
	2: "MIN",
	3: "MAX",
}
var SplittingAlgorithm_value = map[string]int32{
	"NONE":         0,
	"PROPORTIONAL": 1,
	"MIN":          2,
	"MAX":          3,
}

func (x SplittingAlgorithm) String() string {
	return proto.EnumName(SplittingAlgorithm_name, int32(x))
}
func (SplittingAlgorithm) EnumDescriptor() ([]byte, []int) { return fileDescriptor1, []int{1} }

// Benchmark describes a way to measure hardware performance
type Benchmark struct {
	ID                 uint64             `protobuf:"varint,1,opt,name=ID" json:"ID,omitempty"`
	Code               string             `protobuf:"bytes,2,opt,name=code" json:"code,omitempty"`
	Type               DeviceType         `protobuf:"varint,3,opt,name=type,enum=sonm.DeviceType" json:"type,omitempty"`
	Description        string             `protobuf:"bytes,4,opt,name=description" json:"description,omitempty"`
	Image              string             `protobuf:"bytes,5,opt,name=image" json:"image,omitempty"`
	Result             uint64             `protobuf:"varint,6,opt,name=result" json:"result,omitempty"`
	SplittingAlgorithm SplittingAlgorithm `protobuf:"varint,7,opt,name=splittingAlgorithm,enum=sonm.SplittingAlgorithm" json:"splittingAlgorithm,omitempty"`
}

func (m *Benchmark) Reset()                    { *m = Benchmark{} }
func (m *Benchmark) String() string            { return proto.CompactTextString(m) }
func (*Benchmark) ProtoMessage()               {}
func (*Benchmark) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

func (m *Benchmark) GetID() uint64 {
	if m != nil {
		return m.ID
	}
	return 0
}

func (m *Benchmark) GetCode() string {
	if m != nil {
		return m.Code
	}
	return ""
}

func (m *Benchmark) GetType() DeviceType {
	if m != nil {
		return m.Type
	}
	return DeviceType_DEV_UNKNOWN
}

func (m *Benchmark) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *Benchmark) GetImage() string {
	if m != nil {
		return m.Image
	}
	return ""
}

func (m *Benchmark) GetResult() uint64 {
	if m != nil {
		return m.Result
	}
	return 0
}

func (m *Benchmark) GetSplittingAlgorithm() SplittingAlgorithm {
	if m != nil {
		return m.SplittingAlgorithm
	}
	return SplittingAlgorithm_NONE
}

func init() {
	proto.RegisterType((*Benchmark)(nil), "sonm.Benchmark")
	proto.RegisterEnum("sonm.DeviceType", DeviceType_name, DeviceType_value)
	proto.RegisterEnum("sonm.SplittingAlgorithm", SplittingAlgorithm_name, SplittingAlgorithm_value)
}

func init() { proto.RegisterFile("benchmarks.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 360 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x6c, 0x91, 0x4d, 0x6b, 0xdc, 0x30,
	0x10, 0x86, 0xe3, 0x8f, 0xf5, 0x36, 0xb3, 0x65, 0x23, 0xa6, 0xa5, 0xe8, 0x68, 0x42, 0x0e, 0x4b,
	0xa0, 0x5e, 0x68, 0x8f, 0x3d, 0x79, 0x6b, 0x93, 0x9a, 0x34, 0x92, 0x51, 0xec, 0xa6, 0xf4, 0x12,
	0xb2, 0x8e, 0xf0, 0x8a, 0xae, 0x2d, 0x63, 0x2b, 0x85, 0x5c, 0xfa, 0x97, 0xfb, 0x17, 0x8a, 0x95,
	0x9a, 0x06, 0x36, 0xb7, 0x79, 0x9f, 0x97, 0x19, 0x1e, 0x21, 0x20, 0x5b, 0xd9, 0x56, 0xbb, 0xe6,
	0xae, 0xff, 0x39, 0x44, 0x5d, 0xaf, 0x8d, 0x46, 0x7f, 0xd0, 0x6d, 0x73, 0xfa, 0xc7, 0x81, 0xe3,
	0xcd, 0x54, 0xe1, 0x12, 0xdc, 0x2c, 0xa1, 0x4e, 0xe8, 0xac, 0x7c, 0xe1, 0x66, 0x09, 0x22, 0xf8,
	0x95, 0xbe, 0x97, 0xd4, 0x0d, 0x9d, 0xd5, 0xb1, 0xb0, 0x33, 0x9e, 0x81, 0x6f, 0x1e, 0x3b, 0x49,
	0xbd, 0xd0, 0x59, 0x2d, 0x3f, 0x90, 0x68, 0x3c, 0x13, 0x25, 0xf2, 0x97, 0xaa, 0x64, 0xf1, 0xd8,
	0x49, 0x61, 0x5b, 0x0c, 0x61, 0x71, 0x2f, 0x87, 0xaa, 0x57, 0x9d, 0x51, 0xba, 0xa5, 0xbe, 0x3d,
	0xf0, 0x1c, 0xe1, 0x5b, 0x98, 0xa9, 0xe6, 0xae, 0x96, 0x74, 0x66, 0xbb, 0xa7, 0x80, 0xef, 0x20,
	0xe8, 0xe5, 0xf0, 0xb0, 0x37, 0x34, 0xb0, 0x16, 0xff, 0x12, 0x7e, 0x01, 0x1c, 0xba, 0xbd, 0x32,
	0x46, 0xb5, 0x75, 0xbc, 0xaf, 0x75, 0xaf, 0xcc, 0xae, 0xa1, 0x73, 0xeb, 0x40, 0x9f, 0x1c, 0xae,
	0x0f, 0x7a, 0xf1, 0xc2, 0xce, 0xf9, 0x6f, 0x80, 0xff, 0xb6, 0x78, 0x02, 0x8b, 0x24, 0xfd, 0x76,
	0x5b, 0xb2, 0x4b, 0xc6, 0x6f, 0x18, 0x39, 0xc2, 0x05, 0xcc, 0x47, 0xf0, 0x39, 0x2f, 0x89, 0x33,
	0x85, 0x8b, 0xbc, 0x24, 0xee, 0x14, 0x44, 0x7c, 0x45, 0xbc, 0x69, 0xef, 0xba, 0xe0, 0x22, 0xbe,
	0x48, 0x89, 0x8f, 0x08, 0xcb, 0x11, 0xb0, 0xb4, 0xb8, 0xe1, 0xe2, 0xf2, 0x36, 0x63, 0x64, 0x86,
	0x6f, 0xe0, 0xe4, 0x39, 0xe3, 0x65, 0x41, 0x82, 0xf3, 0x0d, 0xe0, 0xa1, 0x29, 0xbe, 0x02, 0x9f,
	0x71, 0x96, 0x92, 0x23, 0x24, 0xf0, 0x3a, 0x17, 0x3c, 0xe7, 0xa2, 0xc8, 0x38, 0x8b, 0xbf, 0x12,
	0x07, 0xe7, 0xe0, 0x5d, 0x65, 0x8c, 0xb8, 0x76, 0x88, 0xbf, 0x13, 0x6f, 0x73, 0xf6, 0xe3, 0xb4,
	0x56, 0x66, 0xf7, 0xb0, 0x8d, 0x2a, 0xdd, 0xac, 0xc7, 0xd7, 0xbf, 0x57, 0x7a, 0x5d, 0xe9, 0x5e,
	0xae, 0xed, 0xe7, 0x7e, 0x1a, 0xd1, 0x36, 0xb0, 0xf3, 0xc7, 0xbf, 0x01, 0x00, 0x00, 0xff, 0xff,
	0xd0, 0x0b, 0x0d, 0x9c, 0xfc, 0x01, 0x00, 0x00,
}
